# Contributing to Microgateway

Hello There! Thank you very much for taking some time for contributing to [Microgateway](https://github.com/wso2/product-microgateway).

This will provide you the required guidelines for contributing to [Microgateway](https://github.com/wso2/product-microgateway)

## Table of Contents
[How To Contribute](#how-to-contribute)
  - [Reporting an issue](#reporting-an-issue)
  - [Your first contribution](#your-first-contribution)
  - [Contributing with code](#contributing-with-code)
    - [Understanding project structure](#understanding-project-structure)
    - [Development environment](#development-environment)
    - [Implementing solution](#implementing-solution)
    - [Debugging the toolkit](#debugging-the-toolkit)

[Ground Rules](#ground-rules)

## How to Contribute
### Reporting an issue
If you find an issue with the product, first search through the existing [issues](https://github.com/wso2/product-microgateway/issues) to find if the issue is already reported.
If your issue is not already reported, fill the project [issue template](https://github.com/wso2/product-microgateway/issues/new) and submit a new issue.
Be kind enough to provide all the details you can provide, when submitting your issue.

### Your first contribution
Not sure where to find a good issue to work on for the first time?
We mark issues with `good first issue` label so that starters can easily find their way in to contributing.
Visit [`good first issue`](https://github.com/wso2/product-microgateway/labels/good%20first%20issue) label, read through the issues and select one for you to work on.
After selecting the issue, communicate that to others by adding a comment. Before starting to work on the issue, discuss your plan/approach with project maintainers.
Then follow [Contributing with code](contributing-with-code) section.

### Contributing with code
If you are familiar with the project and its technologies, you no longer need to check `good first issue`. Browse through all open issues and pick one to work on. Check issues in [`help wanted`](https://github.com/wso2/product-microgateway/labels/help%20wanted) label, where we prioritize issues we need help from you.

### Developer guide
If you are a developer, please refer to the [developer guide](https://github.com/wso2/product-microgateway/blob/main/developer-guide.md) to understand how you can proceed with the code structure.

## Ground Rules
- Follow the contribution guidelines.
- Run the build with tests before submitting your PR.
- Be polite and respectful when communicating with others.
