// Code generated by go-swagger; DO NOT EDIT.

// Copyright (c) 2021, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package authorization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"context"
	"net/http"

	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// PostOauth2TokenHandlerFunc turns a function with the right signature into a post oauth2 token handler
type PostOauth2TokenHandlerFunc func(PostOauth2TokenParams) middleware.Responder

// Handle executing the request and returning a response
func (fn PostOauth2TokenHandlerFunc) Handle(params PostOauth2TokenParams) middleware.Responder {
	return fn(params)
}

// PostOauth2TokenHandler interface for that can handle valid post oauth2 token params
type PostOauth2TokenHandler interface {
	Handle(PostOauth2TokenParams) middleware.Responder
}

// NewPostOauth2Token creates a new http.Handler for the post oauth2 token operation
func NewPostOauth2Token(ctx *middleware.Context, handler PostOauth2TokenHandler) *PostOauth2Token {
	return &PostOauth2Token{Context: ctx, Handler: handler}
}

/* PostOauth2Token swagger:route POST /oauth2/token Authorization postOauth2Token

Get an access token

This operation can be used to get an access token by providing the username and password
in the autherization header


*/
type PostOauth2Token struct {
	Context *middleware.Context
	Handler PostOauth2TokenHandler
}

func (o *PostOauth2Token) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewPostOauth2TokenParams()
	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}

// PostOauth2TokenOKBody post oauth2 token o k body
//
// swagger:model PostOauth2TokenOKBody
type PostOauth2TokenOKBody struct {

	// access token
	AccessToken string `json:"accessToken,omitempty"`
}

// Validate validates this post oauth2 token o k body
func (o *PostOauth2TokenOKBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this post oauth2 token o k body based on context it is used
func (o *PostOauth2TokenOKBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *PostOauth2TokenOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostOauth2TokenOKBody) UnmarshalBinary(b []byte) error {
	var res PostOauth2TokenOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
