/*
 * Choreo-Connect Interceptor Service
 *
 * Interceptor Service
 *
 * API version: v1
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package main

import (
	"crypto/tls"
	"crypto/x509"
	"io/ioutil"
	"log"
	"net/http"

	sw "./go"
)

func main() {
	router := sw.NewRouter()
	// load CA certificate file and add it to list of client CAs
	caCertFile, err := ioutil.ReadFile("./certs/mg.pem")
	if err != nil {
		log.Fatalf("error reading CA certificate: %v", err)
	}
	certPool := x509.NewCertPool()
	certPool.AppendCertsFromPEM(caCertFile)

	// serve on port 9090 of local host
	server := http.Server{
		Addr:    ":9081",
		Handler: router,
		TLSConfig: &tls.Config{
			ClientAuth: tls.RequireAndVerifyClientCert,
			ClientCAs:  certPool,
			MinVersion: tls.VersionTLS11,
		},
	}

	log.Printf("Server started")
	log.Fatal(server.ListenAndServeTLS("certs/interceptor.pem", "certs/interceptor.key"))
}
